package com.persagy.entity;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.persagy.enumeration.NettyMsgTypeEnum;
import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Data
@NoArgsConstructor
public class NettyMessage<T> {
    /*
    唯一标识
     */
    @JSONField()
    private long streamId;
    @JSONField()
    private int version = 1;

    @JSONField()
    private NettyMsgTypeEnum opCode;
    /**
    请求来源
     */
    @JSONField()
    private String source = "project";

    /**
    传输内容
     */
    @JSONField(jsonDirect=true)
    private List<T> content;
    /**
     * 备注说明
     */
    @JSONField()
    private String remark;

    /**
    成功标识
     */
    @JSONField()
    private Boolean success;

    public List<T> getContent() {
        return content;
    }

    public void setContent(List<T> content) {
        this.content = content;
    }

    public NettyMessage(NettyMsgTypeEnum opCode, String source) {
        this.opCode = opCode;
        this.source = source;
    }

    public NettyMessage(String source) {
        this.source = source;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }
}
